﻿using C1.Win.C1FlexGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace FlexGridContext
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            Load += Form1_Load;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            fg.ColumnContextMenuEnabled = true;
            fg.Cols[0].MinWidth = 10;

            // initialize control
            fg.Styles.Normal.WordWrap = true;
            fg.Cols.Count = 10;
            fg.Rows.Fixed = 2;
            fg.AllowMerging = AllowMergingEnum.FixedOnly;

            // create row headers
            fg.Rows[0].AllowMerging = true;

            // four cells, will merge
            CellRange rng = fg.GetCellRange(0, 1, 0, 4);
            rng.Data = "North";

            // four cells, will merge
            rng = fg.GetCellRange(0, 5, 0, 8);
            rng.Data = "South";
            for (int i = 1; i <= 4; i++)
            {
                fg[1, i] = "Qtr " + i;
                fg[1, i + 4] = "Qtr " + i;
            }

            // create column header
            fg.Cols[0].AllowMerging = true;

            // align and autozise the cells
            fg.Styles.Fixed.TextAlign = TextAlignEnum.CenterCenter;
            fg.AutoSizeCols(1, fg.Cols.Count - 1, 10);

            fg.ColumnContextMenuOpening += Fg_ColumnContextMenuOpening;
        }

        private void Fg_ColumnContextMenuOpening(object sender, ColumnContextMenuOpeningEventArgs e)
        {
            //cheked if the top-left header cell was clicked
            if (e.Col == 0 && (fg.Rows.Fixed >= 1 && fg.Cols.Fixed >= 1))
            {
                //clear context menu 
                e.ContextMenuStrip.Items.Clear();

                //create items for columns
                for (int i = 1; i < fg.Cols.Count; i++)
                {
                    var item = new ToolStripMenuItem();
                    //get the merged range that contains the header cell
                    var mergedRange = fg.GetMergedRange(0, i);
                    item.CheckOnClick = true;
                    item.Checked = fg.Cols[i].Visible;
                    item.Tag = mergedRange;
                    item.Click += Btn_Click;
                    item.Text = fg.Cols[i].Caption;
                    e.ContextMenuStrip.Items.Add(item);
                    //if cell is merged skip the merged columns
                    if (!mergedRange.IsSingleCell || !(mergedRange.c1 ==mergedRange.c2))
                    {
                        i = mergedRange.c2;

                    }
                }
            }
        }


        private void Btn_Click(object sender, EventArgs e)
        {
            //hide all columns of the cell range
            var btn = sender as ToolStripMenuItem;
            var col = (CellRange)btn.Tag;
            for (int i = col.c1; i <= col.c2; i++) {
                fg.Cols[i].Visible = btn.Checked;
            }
        }
    }
}
